"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
/*
 * @vuepress
 * ---
 * title: Main
 * headline: The Main File
 * ---
 */
var chalk_1 = __importDefault(require("chalk"));
var chokidar_1 = __importDefault(require("chokidar"));
var del_1 = __importDefault(require("del"));
var promises_1 = __importDefault(require("fs/promises"));
var mkdirp_1 = __importDefault(require("mkdirp"));
var path_1 = require("path");
var readline_1 = __importDefault(require("readline"));
var constants_1 = require("./constants");
var list_folder_1 = require("./lib/list-folder");
var parser_1 = require("./lib/parser");
var vue_sidebar_1 = require("./lib/vue-sidebar");
/**
 * Create the sidebar
 * @param options
 * @returns Promise
 */
var createVuepressSidebar = function (options) {
    return promises_1.default.writeFile(options.docsFolder + "/config.js", "exports.fileTree=" + JSON.stringify(options.fileTree) + ";exports.sidebarTree = (title = 'Mainpage') => (" + JSON.stringify((0, vue_sidebar_1.generateVueSidebar)(options)).replace('::vuepress-jsdoc-title::', '"+title+"') + ");");
};
/**
 * Parse file
 * @param file
 * @param argv
 * @returns Promise
 */
var parseDirectoryFile = function (file, argv) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, srcFolder, docsFolder, partials, dest, content;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = parseArguments(argv), srcFolder = _a.srcFolder, docsFolder = _a.docsFolder, partials = _a.partials;
                if (!(!file.isDir && file.folder)) return [3 /*break*/, 5];
                dest = (0, path_1.join)(docsFolder, file.folder.replace(srcFolder, ''));
                content = void 0;
                if (!['.jsx', '.tsx', '.ts', '.js'].includes(file.ext || '')) return [3 /*break*/, 2];
                return [4 /*yield*/, (0, parser_1.parseFile)(file, srcFolder, docsFolder, argv.jsDocConfigPath, partials)];
            case 1:
                content = _b.sent();
                _b.label = 2;
            case 2:
                if (!(file.ext === '.vue')) return [3 /*break*/, 4];
                return [4 /*yield*/, (0, parser_1.parseVueFile)(file, srcFolder, docsFolder)];
            case 3:
                content = _b.sent();
                _b.label = 4;
            case 4: return [2 /*return*/, { content: content, dest: dest }];
            case 5: return [2 /*return*/];
        }
    });
}); };
var createReadmeFile = function (argv, deletedPaths) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, srcFolder, codeFolder, docsFolder, title, readme, readMeContent, readmePath, e_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = parseArguments(argv), srcFolder = _a.srcFolder, codeFolder = _a.codeFolder, docsFolder = _a.docsFolder, title = _a.title, readme = _a.readme;
                readMeContent = "### Welcome to " + title;
                readmePath = readme || srcFolder + "/README.md";
                _b.label = 1;
            case 1:
                _b.trys.push([1, 3, , 4]);
                return [4 /*yield*/, promises_1.default.readFile(readmePath, 'utf-8')];
            case 2:
                readMeContent = _b.sent();
                if (deletedPaths === null || deletedPaths === void 0 ? void 0 : deletedPaths.some(function (p) { return p.indexOf(codeFolder + "/README.md") !== -1; })) {
                    console.log("\n" + chalk_1.default.white.bgBlack(' README ') + " " + chalk_1.default.dim(readmePath.replace('README.md', '')) + chalk_1.default.bold('README.md') + " \u2192  " + chalk_1.default.dim(docsFolder) + chalk_1.default.bold('/README.md'));
                }
                return [3 /*break*/, 4];
            case 3:
                e_1 = _b.sent();
                console.log("\n" + chalk_1.default.white.bgBlack(' README ') + " Add default README.md");
                return [3 /*break*/, 4];
            case 4: return [4 /*yield*/, promises_1.default.writeFile(docsFolder + "/README.md", readMeContent)];
            case 5:
                _b.sent();
                return [2 /*return*/];
        }
    });
}); };
/**
 * Parse all CLI arguments
 * @param argv
 * @returns all arguments
 */
var parseArguments = function (argv) {
    return {
        exclude: (argv.exclude || '').split(',').filter(Boolean),
        srcFolder: argv.source.replace('./', ''),
        codeFolder: argv.folder,
        docsFolder: argv.dist + "/" + argv.folder,
        title: argv.title,
        readme: argv.readme,
        rmPattern: argv.rmPattern || [],
        partials: argv.partials || []
    };
};
/**
 * Default command that generate md files
 * @param {object} argv passed arguments
 */
var generate = function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exclude, srcFolder, codeFolder, docsFolder, title, rmPattern, startTime, deletedPaths, lsFolder, parsePromises, _b, _c, file, e_2_1, _d, _e, file, data, e_3_1, result, _f, _g, file, _h, _j, entry, color, resultTime;
    var e_2, _k, e_3, _l, e_4, _m, e_5, _o, _p;
    return __generator(this, function (_q) {
        switch (_q.label) {
            case 0:
                _a = parseArguments(argv), exclude = _a.exclude, srcFolder = _a.srcFolder, codeFolder = _a.codeFolder, docsFolder = _a.docsFolder, title = _a.title, rmPattern = _a.rmPattern;
                startTime = +new Date();
                return [4 /*yield*/, (0, del_1.default)(__spreadArray([docsFolder + "/**/*"], __read(rmPattern), false))];
            case 1:
                deletedPaths = _q.sent();
                return [4 /*yield*/, (0, list_folder_1.listFolder)(srcFolder, exclude)];
            case 2:
                lsFolder = _q.sent();
                return [4 /*yield*/, (0, mkdirp_1.default)(docsFolder)];
            case 3:
                _q.sent();
                parsePromises = [];
                _q.label = 4;
            case 4:
                _q.trys.push([4, 9, 10, 11]);
                _b = __values(lsFolder.paths), _c = _b.next();
                _q.label = 5;
            case 5:
                if (!!_c.done) return [3 /*break*/, 8];
                file = _c.value;
                if (!!file.isDir) return [3 /*break*/, 7];
                readline_1.default.clearLine(process.stdout, 0);
                readline_1.default.cursorTo(process.stdout, 0);
                process.stdout.write(chalk_1.default.dim(" " + file.path + " "));
                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 20); })];
            case 6:
                _q.sent();
                _q.label = 7;
            case 7:
                _c = _b.next();
                return [3 /*break*/, 5];
            case 8: return [3 /*break*/, 11];
            case 9:
                e_2_1 = _q.sent();
                e_2 = { error: e_2_1 };
                return [3 /*break*/, 11];
            case 10:
                try {
                    if (_c && !_c.done && (_k = _b.return)) _k.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
                return [7 /*endfinally*/];
            case 11:
                readline_1.default.clearLine(process.stdout, 0);
                readline_1.default.cursorTo(process.stdout, 0);
                _q.label = 12;
            case 12:
                _q.trys.push([12, 17, 18, 19]);
                _d = __values(lsFolder.paths), _e = _d.next();
                _q.label = 13;
            case 13:
                if (!!_e.done) return [3 /*break*/, 16];
                file = _e.value;
                return [4 /*yield*/, parseDirectoryFile(file, argv)];
            case 14:
                data = _q.sent();
                if (data) {
                    parsePromises.push((0, parser_1.writeContentToFile)(data.content, data.dest));
                }
                _q.label = 15;
            case 15:
                _e = _d.next();
                return [3 /*break*/, 13];
            case 16: return [3 /*break*/, 19];
            case 17:
                e_3_1 = _q.sent();
                e_3 = { error: e_3_1 };
                return [3 /*break*/, 19];
            case 18:
                try {
                    if (_e && !_e.done && (_l = _d.return)) _l.call(_d);
                }
                finally { if (e_3) throw e_3.error; }
                return [7 /*endfinally*/];
            case 19: return [4 /*yield*/, Promise.all(parsePromises)];
            case 20:
                result = _q.sent();
                // write vuepress sidebar
                return [4 /*yield*/, createVuepressSidebar({
                        fileTree: lsFolder.tree,
                        srcFolder: srcFolder,
                        docsFolder: docsFolder,
                        codeFolder: codeFolder,
                        title: title
                    })];
            case 21:
                // write vuepress sidebar
                _q.sent();
                try {
                    // print stats
                    for (_f = __values(lsFolder.excluded), _g = _f.next(); !_g.done; _g = _f.next()) {
                        file = _g.value;
                        console.log(chalk_1.default.reset.inverse.bold.blue(' EXCLUDE '), "" + chalk_1.default.dim(file.folder) + chalk_1.default.bold(file.name + file.ext));
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_m = _f.return)) _m.call(_f);
                    }
                    finally { if (e_4) throw e_4.error; }
                }
                console.log();
                try {
                    for (_h = __values(result.flat()), _j = _h.next(); !_j.done; _j = _h.next()) {
                        entry = _j.value;
                        if (!entry.file)
                            continue;
                        color = (_p = {},
                            _p[constants_1.StatisticType.SUCCESS] = 'green',
                            _p[constants_1.StatisticType.ERROR] = 'red',
                            _p[constants_1.StatisticType.EMPTY] = 'yellow',
                            _p[constants_1.StatisticType.EXCLUDE] = 'blue',
                            _p)[entry.type];
                        console.log(chalk_1.default.reset.inverse.bold[color](" " + entry.type + " "), "" + chalk_1.default.dim(entry.relativePathSrc) + chalk_1.default.bold(entry.file.name + entry.file.ext) + " \u2192 " + chalk_1.default.dim(entry.relativePathDest) + chalk_1.default.bold(entry.file.name + '.md'));
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (_j && !_j.done && (_o = _h.return)) _o.call(_h);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
                // create README.md
                return [4 /*yield*/, createReadmeFile(argv, deletedPaths)];
            case 22:
                // create README.md
                _q.sent();
                resultTime = (Math.abs(startTime - +new Date()) / 1000).toFixed(2);
                console.log("\n\u23F0 Time: " + resultTime + "s");
                watchFiles(argv);
                return [2 /*return*/];
        }
    });
}); };
exports.generate = generate;
var watchFiles = function (argv) {
    var _a = parseArguments(argv), exclude = _a.exclude, srcFolder = _a.srcFolder, codeFolder = _a.codeFolder, docsFolder = _a.docsFolder, title = _a.title;
    if (argv.watch) {
        console.log('\n---\n\n👀 watching files...');
        var watcher = chokidar_1.default.watch([srcFolder, argv.readme, srcFolder + "/README.md"].filter(Boolean), {
            ignored: /(^|[\/\\])\../,
            persistent: true
        });
        watcher.on('change', function (path) { return __awaiter(void 0, void 0, void 0, function () {
            var lsFolder, file, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, list_folder_1.listFolder)(srcFolder, exclude)];
                    case 1:
                        lsFolder = _a.sent();
                        file = lsFolder.paths.find(function (p) { return p.path === path; });
                        readline_1.default.clearLine(process.stdout, 0);
                        readline_1.default.cursorTo(process.stdout, 0);
                        if (!(path === 'README.md' || path === srcFolder + "/README.md")) return [3 /*break*/, 3];
                        return [4 /*yield*/, createReadmeFile(argv)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!file) return [3 /*break*/, 8];
                        process.stdout.write(chalk_1.default.dim("update " + (file.name + file.ext)));
                        return [4 /*yield*/, parseDirectoryFile(file, argv)];
                    case 4:
                        data = _a.sent();
                        if (!data) return [3 /*break*/, 6];
                        return [4 /*yield*/, (0, parser_1.writeContentToFile)(data.content, data.dest)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [4 /*yield*/, createVuepressSidebar({
                            fileTree: lsFolder.tree,
                            srcFolder: srcFolder,
                            docsFolder: docsFolder,
                            codeFolder: codeFolder,
                            title: title
                        })];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        }); });
    }
};
/**
 * The vuepress plugins
 * @param argv
 * @param ctx
 * @returns plugin
 */
var plugin = function (argv, ctx) { return ({
    name: 'vuepress-plugin-jsdoc',
    ready: function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (!ctx.isProd) {
                argv.watch = true;
                watchFiles(argv);
            }
            return [2 /*return*/];
        });
    }); }
}); };
exports.default = plugin;
