"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.listFolder = void 0;
var promises_1 = __importDefault(require("fs/promises"));
var micromatch_1 = __importDefault(require("micromatch"));
var path_1 = __importDefault(require("path"));
/**
 * Recursively traverse folders and return exluded files, a file list and a file tree.
 * @param srcPath
 * @param exclude
 * @param mainPath
 * @param tree
 * @returns paths array, tree, excluded array
 */
var listFolder = function (srcPath, exclude, mainPath, tree) {
    if (exclude === void 0) { exclude = []; }
    if (tree === void 0) { tree = []; }
    return __awaiter(void 0, void 0, void 0, function () {
        var paths, excluded, dirs, dirs_1, dirs_1_1, dirent, filePath, isDir, ext, name_1, folder, file, treeEntry, _a, _b, _c, _d, e_1_1;
        var e_1, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    paths = [];
                    excluded = [];
                    return [4 /*yield*/, promises_1.default.readdir(srcPath, {
                            withFileTypes: true
                        })];
                case 1:
                    dirs = _f.sent();
                    _f.label = 2;
                case 2:
                    _f.trys.push([2, 9, 10, 11]);
                    dirs_1 = __values(dirs), dirs_1_1 = dirs_1.next();
                    _f.label = 3;
                case 3:
                    if (!!dirs_1_1.done) return [3 /*break*/, 8];
                    dirent = dirs_1_1.value;
                    filePath = path_1.default.join(srcPath, dirent.name);
                    isDir = dirent.isDirectory();
                    ext = path_1.default.extname(filePath);
                    name_1 = path_1.default.basename(filePath).replace(ext, '');
                    folder = filePath.replace(name_1, '').replace(ext, '');
                    if (name_1 === 'index') {
                        name_1 = '__index__';
                    }
                    file = __assign({ isDir: isDir, name: name_1, path: filePath }, (!isDir ? { ext: ext, folder: folder } : {}));
                    // skip readmes as they are automatically resolved
                    if (name_1.toLowerCase() === 'readme')
                        return [3 /*break*/, 7];
                    if (!!micromatch_1.default.isMatch(path_1.default.join(srcPath.replace(mainPath || srcPath, ''), dirent.name), exclude)) return [3 /*break*/, 6];
                    treeEntry = __assign({ name: name_1 }, (!isDir ? { path: "/" + name_1, fullPath: path_1.default.join(srcPath, name_1), ext: ext } : {}));
                    tree.push(treeEntry);
                    if (!isDir) return [3 /*break*/, 5];
                    treeEntry.children = [];
                    _b = (_a = paths.push).apply;
                    _c = [paths];
                    _d = [[]];
                    return [4 /*yield*/, (0, exports.listFolder)(filePath, exclude, mainPath || srcPath, treeEntry.children)];
                case 4:
                    _b.apply(_a, _c.concat([__spreadArray.apply(void 0, _d.concat([__read.apply(void 0, [(_f.sent()).paths]), false]))]));
                    _f.label = 5;
                case 5:
                    paths.push(file);
                    return [3 /*break*/, 7];
                case 6:
                    excluded.push(file);
                    _f.label = 7;
                case 7:
                    dirs_1_1 = dirs_1.next();
                    return [3 /*break*/, 3];
                case 8: return [3 /*break*/, 11];
                case 9:
                    e_1_1 = _f.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 11];
                case 10:
                    try {
                        if (dirs_1_1 && !dirs_1_1.done && (_e = dirs_1.return)) _e.call(dirs_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 11: return [2 /*return*/, { paths: paths, tree: tree, excluded: excluded }];
            }
        });
    });
};
exports.listFolder = listFolder;
