import { StatisticType } from '../constants';
import { DirectoryFile, ParseReturn } from '../interfaces';
/**
 * Parse a typescript or javascript file
 * @param file
 * @param srcFolder
 * @param destFolder
 * @param configPath
 * @param partials
 * @returns file data
 */
export declare const parseFile: (file: DirectoryFile, srcFolder: string, destFolder: string, configPath: string, partials: string | string[]) => Promise<ParseReturn | null>;
/**
 * Parse a vue file
 * @param file
 * @param srcFolder
 * @param destFolder
 * @returns file data
 */
export declare const parseVueFile: (file: DirectoryFile, srcFolder: string, destFolder: string) => Promise<ParseReturn | null>;
/**
 * Write content on disk
 * @param parseData
 * @param dest
 * @returns null or type with some data of the saved file
 */
export declare const writeContentToFile: (parseData: ParseReturn | null, dest: string) => Promise<{
    type: StatisticType;
    success?: boolean | undefined;
    dest?: string | undefined;
    file?: DirectoryFile | undefined;
    content?: string | undefined;
    empty?: boolean | undefined;
    excluded?: boolean | undefined;
    relativePathSrc?: string | undefined;
    relativePathDest?: string | undefined;
} | null>;
