"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeContentToFile = exports.parseVueFile = exports.parseFile = void 0;
var promises_1 = __importDefault(require("fs/promises"));
var jsdoc_to_markdown_1 = __importDefault(require("jsdoc-to-markdown"));
var mkdirp_1 = __importDefault(require("mkdirp"));
var path_1 = require("path");
var compileTemplates_1 = __importDefault(require("vue-docgen-cli/lib/compileTemplates"));
var docgen_1 = require("vue-docgen-cli/lib/docgen");
var constants_1 = require("../constants");
var comment_parser_1 = require("./comment-parser");
/**
 * Parse a typescript or javascript file
 * @param file
 * @param srcFolder
 * @param destFolder
 * @param configPath
 * @param partials
 * @returns file data
 */
var parseFile = function (file, srcFolder, destFolder, configPath, partials) { return __awaiter(void 0, void 0, void 0, function () {
    var root, relativePathDest, folderInDest, folderInSrc, success, empty, excluded, fileContent, content, fileName, _a, e_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!file.folder)
                    return [2 /*return*/, null];
                root = process.cwd();
                relativePathDest = (0, path_1.join)(destFolder, file.folder.replace(srcFolder, ''));
                folderInDest = (0, path_1.join)(root, relativePathDest);
                folderInSrc = (0, path_1.join)(root, file.folder);
                success = true;
                empty = false;
                excluded = false;
                fileContent = '';
                _b.label = 1;
            case 1:
                _b.trys.push([1, 4, , 5]);
                content = '';
                fileName = file.name;
                if (fileName === '__index__') {
                    fileName = 'index';
                }
                return [4 /*yield*/, jsdoc_to_markdown_1.default.render({
                        files: [(0, path_1.join)(process.cwd(), file.folder, fileName + file.ext)],
                        configure: configPath,
                        partial: __spreadArray([
                            (0, path_1.resolve)(__filename, '../../../template/header.hbs'),
                            (0, path_1.resolve)(__filename, '../../../template/main.hbs')
                        ], __read(partials), false)
                    })];
            case 2:
                content = _b.sent();
                _a = comment_parser_1.parseVuepressFileHeader;
                return [4 /*yield*/, promises_1.default.readFile("" + (0, path_1.join)(folderInSrc, fileName + file.ext), 'utf-8')];
            case 3:
                fileContent = _a.apply(void 0, [_b.sent(), file]);
                if (content) {
                    fileContent += content;
                }
                else {
                    empty = true;
                }
                return [3 /*break*/, 5];
            case 4:
                e_1 = _b.sent();
                success = false;
                excluded = true;
                return [3 /*break*/, 5];
            case 5: return [2 /*return*/, {
                    success: success,
                    file: file,
                    empty: empty,
                    excluded: excluded,
                    relativePathDest: relativePathDest,
                    relativePathSrc: file.folder,
                    dest: folderInDest,
                    content: fileContent
                }];
        }
    });
}); };
exports.parseFile = parseFile;
/**
 * Parse a vue file
 * @param file
 * @param srcFolder
 * @param destFolder
 * @returns file data
 */
var parseVueFile = function (file, srcFolder, destFolder) { return __awaiter(void 0, void 0, void 0, function () {
    var root, relativePathDest, folderInDest, folderInSrc, config, success, empty, fileContent, fileName, data, _a, e_2;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (!file.folder)
                    return [2 /*return*/, null];
                root = process.cwd();
                relativePathDest = (0, path_1.join)(destFolder, file.folder.replace(srcFolder, ''));
                folderInDest = (0, path_1.join)(root, relativePathDest);
                folderInSrc = (0, path_1.join)(root, file.folder);
                config = __assign(__assign({}, (0, docgen_1.extractConfig)((0, path_1.join)(root, file.folder))), { components: file.name + file.ext });
                success = true;
                empty = false;
                fileContent = '';
                _b.label = 1;
            case 1:
                _b.trys.push([1, 4, , 5]);
                fileName = file.name;
                if (fileName === '__index__') {
                    fileName = 'index';
                }
                return [4 /*yield*/, (0, compileTemplates_1.default)((0, path_1.join)(config.componentsRoot, fileName + file.ext), config, fileName + file.ext)];
            case 2:
                data = _b.sent();
                _a = comment_parser_1.parseVuepressFileHeader;
                return [4 /*yield*/, promises_1.default.readFile("" + (0, path_1.join)(folderInSrc, fileName + file.ext), 'utf-8')];
            case 3:
                fileContent = _a.apply(void 0, [_b.sent(), file]);
                if (data.content) {
                    fileContent += data.content;
                }
                else {
                    empty = true;
                }
                return [3 /*break*/, 5];
            case 4:
                e_2 = _b.sent();
                console.log(e_2);
                success = false;
                return [3 /*break*/, 5];
            case 5: return [2 /*return*/, {
                    success: success,
                    file: file,
                    empty: empty,
                    relativePathDest: relativePathDest,
                    relativePathSrc: file.folder,
                    dest: folderInDest,
                    content: fileContent
                }];
        }
    });
}); };
exports.parseVueFile = parseVueFile;
/**
 * Write content on disk
 * @param parseData
 * @param dest
 * @returns null or type with some data of the saved file
 */
var writeContentToFile = function (parseData, dest) { return __awaiter(void 0, void 0, void 0, function () {
    var root, type, path, _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                root = process.cwd();
                dest = (0, path_1.join)(root, dest);
                type = constants_1.StatisticType.ERROR;
                if (parseData === null || parseData === void 0 ? void 0 : parseData.excluded) {
                    type = constants_1.StatisticType.EXCLUDE;
                }
                _b.label = 1;
            case 1:
                _b.trys.push([1, 5, , 6]);
                if (!(parseData === null || parseData === void 0 ? void 0 : parseData.content)) return [3 /*break*/, 4];
                path = (0, path_1.join)(dest, parseData.file.name) + ".md";
                return [4 /*yield*/, (0, mkdirp_1.default)(dest)];
            case 2:
                _b.sent();
                return [4 /*yield*/, promises_1.default.writeFile(path, parseData.content, 'utf-8')];
            case 3:
                _b.sent();
                type = (parseData === null || parseData === void 0 ? void 0 : parseData.empty) ? constants_1.StatisticType.EMPTY : constants_1.StatisticType.SUCCESS;
                _b.label = 4;
            case 4: return [2 /*return*/, __assign(__assign({}, parseData), { type: type })];
            case 5:
                _a = _b.sent();
                return [3 /*break*/, 6];
            case 6: return [2 /*return*/, null];
        }
    });
}); };
exports.writeContentToFile = writeContentToFile;
