"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateVueSidebar = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = require("path");
/**
 * Runs through the given tree structure and creates a vuepress config
 * @param param0
 * @returns returns the vuepress menu strcture
 */
var generateVueSidebar = function (_a) {
    var _b;
    var fileTree = _a.fileTree, codeFolder = _a.codeFolder, srcFolder = _a.srcFolder, docsFolder = _a.docsFolder, title = _a.title;
    var rootFiles = [['', '::vuepress-jsdoc-title::']];
    rootFiles = rootFiles.concat(fileTree.filter(function (file) { return !file.children; }).map(function (file) { return file.name; }));
    var rootFolder = fileTree.filter(function (file) { return file.children && file.children.length > 0; });
    var buildChildren = function (children, name, depth) {
        var e_1, _a;
        var newChildren = [];
        try {
            for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                var child = children_1_1.value;
                if (child.children && child.children.length > 0) {
                    newChildren = newChildren.concat(buildChildren(child.children, child.name, depth + 1));
                }
                else if (child.fullPath) {
                    if (fs_1.default.existsSync((0, path_1.join)(docsFolder, child.fullPath.replace(srcFolder, '')) + '.md')) {
                        newChildren.push(child.fullPath.replace(srcFolder + "/", ''));
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return newChildren;
    };
    var tree = rootFolder.map(function (folder) { return ({
        title: folder.name,
        collapsable: false,
        children: buildChildren(folder.children, folder.name, 0)
    }); });
    return _b = {},
        _b["/" + codeFolder + "/"] = [
            {
                title: title,
                collapsable: false,
                children: rootFiles
            }
        ].concat(tree),
        _b;
};
exports.generateVueSidebar = generateVueSidebar;
